| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
Genfun::GaudiMathImplementation::GSLSpline Class Reference

`#include <GaudiMath/Splines.h>`

Inheritance diagram for Genfun::GaudiMathImplementation::GSLSpline:
[legend]
Collaboration diagram for Genfun::GaudiMathImplementation::GSLSpline:
[legend]

## Public Types
typedef SplineBase::Data1D | Data1D
typedef SplineBase::Data2D | Data2D

## Public Member Functions
| GSLSpline (const Data1D &x, const Data1D &y, const GaudiMath::Interpolation::Type type)
| mandatory macro from CLHEP/GenericFunctions More...
| GSLSpline (const Data2D &data, const GaudiMath::Interpolation::Type type)
| constructor from data vector More...
template<class DATAX , class DATAY >
| GSLSpline (const GaudiMath::Interpolation::Type type, DATAX begin_x, DATAX end_x, DATAY begin_y)
| templated constructor in the spirit of STL-algorithms More...
template<class DATA >
| GSLSpline (const GaudiMath::Interpolation::Type type, DATA begin, DATA end)
| templated constructor from the sequence of pairs as sequence of pairs the class TabulatedProperty can be used More...
| GSLSpline (const SplineBase &)
| constructor from base More...
| GSLSpline (const GSLSpline &)
| copy constructor More...
virtual | ~GSLSpline ()
| destructor More...
virtual double | operator() (double a) const
| main methgod: evaluate teh function More...
virtual double | operator() (const Argument &x) const
| main methgod: evaluate teh function More...
virtual unsigned int | dimensionality () const
virtual bool | hasAnalyticDerivative () const
| Does this function have an analytic derivative? More...
virtual Genfun::Derivative | partial (unsigned int i) const
| Derivatives. More...
const SplineBase & | spline () const
| acess to the spline function More...
| operator const SplineBase & () const
| cast operator to the spline function More...

## Private Member Functions
| GSLSpline ()=delete
| default construtor is disabled ; More...
GSLSpline & | operator= (const GSLSpline &)=delete
| assignement operator is disabled ; More...

## Private Attributes
SplineBase | m_spline

## Detailed Description

Definition at line 133 of file Splines.h.

## Member Typedef Documentation

typedef SplineBase::Data1D Genfun::GaudiMathImplementation::GSLSpline::Data1D

Definition at line 136 of file Splines.h.

typedef SplineBase::Data2D Genfun::GaudiMathImplementation::GSLSpline::Data2D

Definition at line 137 of file Splines.h.

## Constructor & Destructor Documentation

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const Data1D & | x,
|  | const Data1D & | y,
|  | const GaudiMath::Interpolation::Type | type
| ) |  |

mandatory macro from CLHEP/GenericFunctions

constructor from vectors and type

constructor from vectors and type

Data1D x = .. ;
Data1D y = .. ;
const AbsFunction& func =
GSLSpline( x , y , GaudiMath::Interpolation::Cspline ) ;
const double value = 1 ;
const double result = func( value ) ;

Parameters

  x | vector of x
  y | vector of y
  type | interpolation type

Data1D x = .. ;
Data1D y = .. ;
const AbsFunction& func =
GSLSpline( x , y , GaudiMath::Interpolation::Cspline ) ;
const double value = 1 ;
const double result = func( value ) ;

Parameters

  x | vector of x
  y | vector of y
  type | interpolation type

Definition at line 207 of file Splines.cpp.

210 : AbsFunction ()
211 , m_spline ( x , y , type )
212 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const Data2D & | data,
|  | const GaudiMath::Interpolation::Type | type
| ) |  |

constructor from data vector

Data2D data = ... ;
const AbsFunction& func =
GSLSpline( data , GaudiMath::Interpolation::Cspline );
const double value = 1 ;
const double result = func( value ) ;

Parameters

  data | vector of (x,y) pairs
  type | interpolation type

Definition at line 236 of file Splines.cpp.

238 : AbsFunction ()
239 , m_spline ( data , type )
240 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269
template<class DATAX , class DATAY >

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const GaudiMath::Interpolation::Type | type,
|  | DATAX | begin_x,
|  | DATAX | end_x,
|  | DATAY | begin_y
| ) |  |
| inline

templated constructor in the spirit of STL-algorithms

It is assumed that vector "y" has tehlength AT LEAST as long as "x"

SEQURNCE1 x = .. ;
SEQUENCE2 y = .. ;
const AbsFunction& func =
GSLSpline( GaudiMath::Interpoaltion::Cspline ,
x.begin () ,
x.end () ,
y.begin () );
const double value = 1 ;
const double result = func( value ) ;

Parameters

  begin_x | begin of X-sequence
  end_x | end of X-sequence
  begin_Y | begin of Y-sequence
  type | interpolation type

Definition at line 215 of file Splines.h.

219 : AbsFunction ( )
220 , m_spline( type , begin_x , end_x , begin_y )
221 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269
template<class DATA >

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const GaudiMath::Interpolation::Type | type,
|  | DATA | begin,
|  | DATA | end
| ) |  |
| inline

templated constructor from the sequence of pairs as sequence of pairs the class TabulatedProperty can be used

Parameters

  begin | begin of sequence of pairs
  end | end of sequence of pairs
  type | interpolation type

Definition at line 235 of file Splines.h.

238 : AbsFunction ( )
239 , m_spline( type , begin , end )
240 {}
begin
auto begin(reverse_wrapper< T > &w)
Definition: reverse.h:45
gaudirun.type
string type
Definition: gaudirun.py:151
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:47
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const SplineBase & | right | ) |

constructor from base

constructor from SplineBase

Definition at line 247 of file Splines.cpp.

248 : AbsFunction ()
249 , m_spline ( right )
250 {}
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( | const GSLSpline & | right | ) |

copy constructor

Definition at line 257 of file Splines.cpp.

258 : AbsFunction ()
259 , m_spline ( right )
260 {}
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

Genfun::GaudiMathImplementation::GSLSpline::~GSLSpline | ( |  | ) |
| virtual default

destructor

Genfun::GaudiMathImplementation::GSLSpline::GSLSpline | ( |  | ) |
| private delete

default construtor is disabled ;

## Member Function Documentation

virtual unsigned int Genfun::GaudiMathImplementation::GSLSpline::dimensionality | ( |  | ) | const
| inline virtual

Definition at line 252 of file Splines.h.

252 { return 1 ; }

virtual bool Genfun::GaudiMathImplementation::GSLSpline::hasAnalyticDerivative | ( |  | ) | const
| inline virtual

Does this function have an analytic derivative?

Definition at line 254 of file Splines.h.

254 { return true ; }

Genfun::GaudiMathImplementation::GSLSpline::operator const SplineBase & | ( |  | ) | const
| inline

cast operator to the spline function

Definition at line 261 of file Splines.h.

261 { return spline() ; }
Genfun::GaudiMathImplementation::GSLSpline::spline
const SplineBase & spline() const
acess to the spline function
Definition: Splines.h:259

double Genfun::GaudiMathImplementation::GSLSpline::operator() | ( | double | a | ) | const
| virtual

main methgod: evaluate teh function

Definition at line 270 of file Splines.cpp.

271 { return m_spline.eval( x ) ; }
Genfun::GaudiMathImplementation::SplineBase::eval
double eval(const double x) const
evaluate the function
Definition: Splines.cpp:147
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

double Genfun::GaudiMathImplementation::GSLSpline::operator() | ( | const Argument & | x | ) | const
| virtual

main methgod: evaluate teh function

Definition at line 273 of file Splines.cpp.

274 { return m_spline.eval( x[0] ) ; }
Genfun::GaudiMathImplementation::SplineBase::eval
double eval(const double x) const
evaluate the function
Definition: Splines.cpp:147
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

GSLSpline& Genfun::GaudiMathImplementation::GSLSpline::operator= | ( | const GSLSpline & |  | ) |
| private delete

assignement operator is disabled ;

Genfun::Derivative Genfun::GaudiMathImplementation::GSLSpline::partial | ( | unsigned int | i | ) | const
| virtual

Derivatives.

Definition at line 280 of file Splines.cpp.

281 {
282 if ( i >= 1 )
283 {
284 const AbsFunction& aux = GaudiMath::Constant( 0.0 , 1 ) ;
285 return Genfun::FunctionNoop( &aux ) ;
286 }
287 const AbsFunction& aux = GSLSplineDeriv( *this ) ;
288 return Genfun::FunctionNoop( &aux ) ;
289 }
ana.i
list i
Definition: ana.py:128
GaudiMath::Constant
Genfun::GaudiMathImplementation::Constant Constant
Definition: GaudiMath.h:27

const SplineBase& Genfun::GaudiMathImplementation::GSLSpline::spline | ( |  | ) | const
| inline

acess to the spline function

Definition at line 259 of file Splines.h.

259 { return m_spline ; }
Genfun::GaudiMathImplementation::GSLSpline::m_spline
SplineBase m_spline
Definition: Splines.h:269

## Member Data Documentation

SplineBase Genfun::GaudiMathImplementation::GSLSpline::m_spline
| private

Definition at line 269 of file Splines.h.

The documentation for this class was generated from the following files:

- GaudiGSL/GaudiMath/Splines.h
- GaudiGSL/src/Lib/Splines.cpp